<script lang="ts" setup>
import { computed, ref } from 'vue'
import GitlabHelperApi from '@/api/gitlabHelperApi'

const props = withDefaults(defineProps<{
  user: { id: number }
}>(), {
  user: () => ({ id: 0 }),
})

const saving = ref(false)
const isError = ref(false)
const isRequest = ref(false)
const requestMessage = ref('')
const groupProject = ref('Vendors')
const groupProjectId = ref(window.GITLAB_VENDOR_ID as string)

const alertToggleVariant = computed(() => isError.value ? 'error' : 'success')
const alertToggleText = computed(() => isError.value ? 'Error!' : 'Success!')

const addGitLabToken = async () => {
  saving.value = true

  const gitlabHelper = new GitlabHelperApi()
  try {
    const response = await gitlabHelper.createGroupToken(groupProjectId.value, props.user.id)

    console.log(':: addGitlabToken.vue:: createGitLabToken response.data:', response.data)
    requestMessage.value = response.data.message
    isError.value = false
    emit('finished')
  }
  catch (error) {
    console.error('error addGitLabUser:', error.response.data)
    requestMessage.value = error.response.data.message
    isError.value = true
  }
  saving.value = false
  isRequest.value = true
}
</script>

<template>
  <h4>AddGitlabToken</h4>
  <VForm
    ref="addGitlabUserForm"
    class="mt-2"
  >
    <VRow>
      <VCol cols="12">
        <VAlert
          v-if="isRequest"
          border="start"
          :color="alertToggleVariant"
          :type="alertToggleVariant"
          dense
        >
          <strong>{{ alertToggleText }}</strong> {{ requestMessage }}.
        </VAlert>
      </VCol>
    </VRow>
    <VRow>
      <VCol
        cols="12"
        sm="6"
      >
        <VTextField
          v-model="groupProject"
          label="Select group/project"
          disabled
        />
      </VCol>
    </VRow>
    <VRow>
      <VCol cols="12">
        <VBtn
          color="primary"
          class="mt-2"
          :disabled="saving"
          @click="addGitLabToken"
        >
          <VProgressCircular
            v-if="saving"
            indeterminate
            size="20"
          />
          <span v-if="saving">Creating token...</span>
          <span v-else>Create token</span>
        </VBtn>
      </VCol>
    </VRow>
  </VForm>
</template>

<style scoped>
</style>
